//
//  Date+Util.swift
//  iLoadProject
//
//  Created by Andre Santana Ferreira on 24/03/17.
//  Copyright © 2017 iLoadProject. All rights reserved.
//

import Foundation

extension Date{
    
    //Presentation Style -> "YYYY-MM-dd"
    //ISO Style -> "yyyy-MM-dd'T'HH:mm:ss.SSSZ"
    
    
    func toString(withDateFormat dateFormat : String) -> String{
        
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = dateFormat
        dateFormatter.locale = Locale.current
        let dateString = dateFormatter.string(from: self)
        return dateString
    }
    
    var toPresentationDateString : String{
        
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "dd/MM/yyyy"
        dateFormatter.locale = Locale.current
        let dateString = dateFormatter.string(from: self)
        return dateString
    }
    
    var toPresentationHourString : String{
        
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "HH:mm:ss"
        dateFormatter.locale = Locale.current
        let dateString = dateFormatter.string(from: self)
        return dateString
    }
    
    var toPresentationFullDateString : String{
        
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "dd/MM/yyyy - HH:mm:ss"
        dateFormatter.locale = Locale.current
        let dateString = dateFormatter.string(from: self)
        return dateString
    }
    
    var toISODateString : String {
        
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd'T'HH:mm:ss.SSSZ"
        dateFormatter.locale = Locale.current
        let dateString = dateFormatter.string(from: self)
        return dateString
    }
    
    var age: Int {
        return Calendar.current.dateComponents([.year, .month, .day], from: self, to: Date()).year!
    }
}
