//
//  Double+Util.swift
//  iLoadProject
//
//  Created by Andre Santana Ferreira on 21/02/17.
//  Copyright © 2017 iLoadProject. All rights reserved.
//

import Foundation

extension Double{
    
    func formatInTime() -> String{
        
        var minutes:UInt8 = 0
        var seconds:UInt8 = 0
        var fraction:UInt8 = 0
        
        if(self >= 0){
            var elapsedTime = self
            minutes = UInt8(elapsedTime / 60.0)
            elapsedTime -= (TimeInterval(minutes) * 60)
            
            seconds = UInt8(elapsedTime)
            elapsedTime -= TimeInterval(seconds)
            
            fraction = UInt8(elapsedTime * 100)
        }
        
        let strMinutes = String(format: "%02d", minutes)
        let strSeconds = String(format: "%02d", seconds)
        let strFraction = String(format: "%02d", fraction)
        
        return "\(strMinutes):\(strSeconds):\(strFraction)"
    }
    
    func format(_ number:Int) -> String{
        return String(format: "%.0\(number)f", self).replacingOccurrences(of: ".", with: ",")
    }
}
