//
//  LPExercise.swift
//  iLoadProject
//
//  Created by Lucas Araujo on 28/10/16.
//  Copyright © 2016 iLoadProject. All rights reserved.
//

import UIKit


enum LPWorkoutLevel {
    case easy
    case medium
    case hard
}

enum LPMuscleGroup{
    case chest
}

class LPExercise: NSObject, NSCoding {

    var id: String!
    var name:String!
    var detail:String!
    
    init(name: String, detail: String) {
        super.init()
        self.id = UUID().uuidString
        self.name = name
        self.detail = detail
    }
    
    override init() {
        
    }
    
    required init?(coder aDecoder: NSCoder) {
        id = aDecoder.decodeObject(forKey: "id") as! String
        name = aDecoder.decodeObject(forKey: "name") as! String
        detail = aDecoder.decodeObject(forKey: "detail") as! String
    }
    
    func encode(with aCoder: NSCoder) {
        aCoder.encode(id, forKey: "id")
        aCoder.encode(name, forKey: "name")
        aCoder.encode(detail, forKey: "detail")
        
    }
    
//    var level:LPWorkoutLevel
//    var muscle:LPMuscleGroup
}

class LPExerciseDAO{
    
    class func save(exercise: LPExercise){
        
        var arrayExercise = self.getAll()
        
        arrayExercise.append(exercise)
        
        let arrayData = NSKeyedArchiver.archivedData(withRootObject: arrayExercise)
        let userDefaults = UserDefaults.standard
        
        userDefaults.set(arrayData, forKey: "Exercise")
        userDefaults.synchronize()
        
    }
    
    class func getAll() -> [LPExercise]{
        
        let userDefaults = UserDefaults.standard
        guard let dataArray = userDefaults.object(forKey: "Exercise") as? Data else{ return []}
        guard let getArrayExercise = NSKeyedUnarchiver.unarchiveObject(with: dataArray) as? [LPExercise] else { return []}
        
        return getArrayExercise
    }
    
    class func remove(exercise : [LPExercise]){
        
        let arrayData = NSKeyedArchiver.archivedData(withRootObject: exercise)
        let userDefaults = UserDefaults.standard
        
        userDefaults.set(arrayData, forKey: "Exercise")
        userDefaults.synchronize()
    }
}
