//
//  LPRepetitionsCountViewController.swift
//  iLoadProject
//
//  Created by Lucas Freitas de Oliveira on 11/11/16.
//  Copyright © 2016 iLoadProject. All rights reserved.
//

import UIKit

protocol PresenteRepetitionsViewControllerDelegate {
    func presentResult(workoutFinal: LPWorkoutFinalResult, load: Double, repetitions: Int)
}

class LPRepetitionsCountViewController: UIAlertController {

    var repetitions:Int!
    var duration:Double!
    var load:Double!
    var distance:Double!
    var delegate:PresenteRepetitionsViewControllerDelegate!
    
    override func viewDidLoad() {
        super.viewDidLoad()
    
    }

    
    class func createRepetitionsDefault(delegate:PresenteRepetitionsViewControllerDelegate) -> LPRepetitionsCountViewController {
        
        let newAlert = LPRepetitionsCountViewController(title: "Número de Repetições", message: "", preferredStyle: .alert)
        
        newAlert.addTextField(configurationHandler: newAlert.configureRepetitionsTextField)
        
        let doneAction = UIAlertAction(title: "Ok", style: .default, handler: newAlert.alertAction)
        newAlert.addAction(doneAction)
        
        let cancelAction = UIAlertAction(title: "Cancel", style: .cancel, handler: nil)
        newAlert.addAction(cancelAction)
        
        newAlert.delegate = delegate
        
        return newAlert
    }
    
    func alertAction(action: UIAlertAction) {
        
        let workoutFinal = LPWorkoutFinalResult(duration: duration, distance: distance, load: load, repetitions: Double(repetitions))
        
        delegate.presentResult(workoutFinal: workoutFinal, load: self.load, repetitions: self.repetitions)
        
    }
    
    func configureRepetitionsTextField(textField:UITextField){
        textField.delegate = self
        textField.tag = ExerciseAlertTextFieldType.repetitions.rawValue
        textField.placeholder = "Número de repetições"
        textField.keyboardType = .numbersAndPunctuation
    }
}

extension LPRepetitionsCountViewController: UITextFieldDelegate {
    func textFieldDidEndEditing(_ textField: UITextField) {
        
        if textField.text!.isEmpty == false{
            
            switch (textField.tag) {
            case ExerciseAlertTextFieldType.repetitions.rawValue:
                repetitions = Int(textField.text!)
                break
            default:
                break
            }
        }
    }
}
