//
//  ResultExport.swift
//  iLoadProject
//
//  Created by Andre Santana Ferreira on 21/03/17.
//  Copyright © 2017 iLoadProject. All rights reserved.
//

import Foundation

class ResultExport: CSVExporting {
    
    ///User
    var user : String!
    var email : String!
    var cpf : String!
    
    ///Exercise
    var nameExercise : String!
    var descriptionExercise: String!
    
    var load: String!
    var repetitions: String!
    var velocity: String!
    var potency: String!
    var work: String!
    var duration: String!
    var distance: String!
    var date: String!
    var hour: String!
    
    init(serie: LPSerie!) {
        
        guard let unrwappedSerie = serie else { return }
        guard let finalResult = unrwappedSerie.finalResult else { return }
        guard let user = finalResult.user else { return }
        guard let exercise = unrwappedSerie.exercise else { return }
        
        self.user = user.name!
        self.email = user.email!
        self.cpf = user.cpf!
        
        self.nameExercise = exercise.name!
        self.descriptionExercise = exercise.detail!
        
        self.load = unrwappedSerie.load!.format(2)
        self.repetitions = "\(unrwappedSerie.repetitions!)"
        
        self.velocity = finalResult.velocity!.format(2)
        self.potency = finalResult.potency!.format(2)
        self.work = finalResult.work!.format(2)
        self.duration = finalResult.duration!.format(2)
        self.distance = finalResult.distance!.format(2)
        self.date = unrwappedSerie.date.toPresentationDateString
        self.hour = unrwappedSerie.date.toPresentationHourString

    }
    
    static func templateString() -> String {
        
        return "User Name; Email; CPF; Exercise Name; Exercise Description; Load (Kg); Repetitions; Time (s); Distance (m); Mean Velocity (m/s); Mean Power (W); Work (J); Date; Hour\n"
    }
    
    
    func exportAsCommaSeparatedString() -> String {
        
        return "\(self.user!); \(self.email!); \(self.cpf!); \(self.nameExercise!); \(self.descriptionExercise!); \(self.load!); \(self.repetitions!); \(self.duration!); \(self.distance!); \(self.velocity!); \(self.potency!); \(self.work!); \(self.date!); \(self.hour!)\n"
    }

    class func toArray(series: [LPSerie]) -> [ResultExport] {
        
        var arrayResultExports = [ResultExport]()
        for serie in series {
            let result = ResultExport(serie: serie)
            arrayResultExports.append(result)
        }
        
        return arrayResultExports
    }
}

/*
 
 var exercise:LPExercise!
 var id: String!
 var name:String!
 var detail:String!
 
 
 var load:Double!
 var repetitions:Int!
 
 var finalResult:LPWorkoutFinalResult!
 var velocity:Double!
 var potency:Double!
 var work:Double!
 var duration:Double!
 var distance:Double!
 var repetitions: Double!
 
 var user: User!
 var id : String!
 var name: String!
 var cpf: String!
 var email: String!
 var isCurrent: Bool!
 
 */
